package ovh.herisson.Clyde.Services.ScientificPublications;

/******************************************************
 * @file StatisticsService
 * @author Bartha Maxime
 * @scope Publications Scientifiques
 *
 * Service for managing statistics
 ******************************************************/
import lombok.AllArgsConstructor;
import org.springframework.stereotype.Service;
import ovh.herisson.Clyde.Repositories.ScientificPublications.ResearchRepository;
import ovh.herisson.Clyde.Repositories.ScientificPublications.StatsRepository;
import ovh.herisson.Clyde.Tables.ScientificPublications.Research;
import ovh.herisson.Clyde.Tables.ScientificPublications.Researcher;

import java.util.*;

@Service
@AllArgsConstructor
public class StatisticsService {


    private ResearchRepository articleRepo;
    private StatsRepository statsRepo;


    public Iterable<Iterable<Map<String, Integer>>> generateStats(Researcher researcher){

        Iterable<Research> researches = articleRepo.findByAuthor(researcher);

        if (researches == null) return null;


        ArrayList<Iterable<Map<String,Integer>>> toReturn = new ArrayList<>();

        toReturn.add(statsRepo.viewsByYears(researcher.getId()));
        toReturn.add(statsRepo.viewsByMonths(researcher.getId()));
        toReturn.add(statsRepo.viewsByTopics(researcher.getId()));

        toReturn.add(statsRepo.researchesByYears(researcher.getId()));
        toReturn.add(statsRepo.researchesByMonth(researcher.getId()));
        toReturn.add(statsRepo.researchesByTopics(researcher.getId()));

        toReturn.add(statsRepo.languageByYears(researcher.getId()));
        toReturn.add(statsRepo.languageByMonths(researcher.getId()));
        toReturn.add(statsRepo.languageByTopics(researcher.getId()));
        return toReturn;
    }
}